<?php
/*
Plugin Name: Filosofo Gravatars
Plugin URI: http://www.ilfilosofo.com/blog/2007/10/23/gravatar-plugin/
Description: Add Gravatars to your WordPress theme in a way that customizes easily and degrades nicely.
Version: 1.8
Author: Austin Matzko
Author URI: http://www.ilfilosofo.com/

Copyright 2008 Austin Matzko if (dot) website (at) gmail (dot) com

License: GPL 2 (same as WordPress)

*/

class filosofo_gravatars {
	function filosofo_gravatars() {
		add_action('gravatar', array(&$this, 'output'));
	}

	function output($args = array()) {
		global $comment;
		if ( empty( $args ) && empty( $comment ) ) 
			return false;
		$defaults = array(
			'alt' => htmlspecialchars( $comment->comment_author ),
			'border' => '',
			'comment_author_email' => $comment->comment_author_email,
			'default' => '',
			'div_class' => '',
			'echo' => true,
			'gravatar_id' => '',
			'img_class' => '',
			'pattern' => '',
			'rating' => '',
			'return' => 'img',
		);

		$args = array_merge( $defaults, (array) $args );
		extract($args, EXTR_SKIP);

		$border = ( empty($border) && ! empty($b) ) ? $b : $border;
		$default = ( empty($default) && ! empty($d) ) ? $d : $default;
		$gravatar_id = ( empty($gravatar_id) && ! empty($g) ) ? $g : $gravatar_id;
		$rating = ( empty($rating) && ! empty($r) ) ? $r : $rating;
		$size = ( empty($size) && ! empty($s) ) ? $s : $size;

		$gravatar_id = ( empty($gravatar_id) ) ? md5( strtolower( $comment_author_email ) ) : $gravatar_id;
		$img_classes = ( empty( $img_class ) ) ? array() : explode(' ', trim($img_class));
		$img_classes[] = 'avatar';

		$path = 'http://www.gravatar.com/avatar/' . $gravatar_id . '?';
		if ( ! empty( $border ) ) 
			$path .= '&amp;border=' . $border;
		if ( ! empty( $rating ) )
			$path .= '&amp;r=' . $rating;
		if ( ! empty( $size ) ) {
			$img_classes[] = "avatar-$size";
			$path .= '&amp;s=' . $size;
		}
		if ( ! empty( $default) && in_array( $default, array('default', 'identicon', 'monsterid', 'wavatar')) )
			$img_classes[] = "avatar-$default";
		if ( ! empty( $default ) ) 
			$path .= '&amp;d=' . urlencode($default);

		$div_class = ( ! empty( $div_class ) ) ? " class=\"$div_class\"" : '';
		$img_class = ' class="' . implode(' ', $img_classes) . '"';

		$result = $path;

		if ( 'div' == $return || 'img' == $return ) 
			$result = "<img src=\"{$result}\" alt=\"{$alt}\"{$img_class} />";
		if ( 'div' == $return )
			$result = "<div{$div_class}>{$result}</div>";
		if ( ! empty( $pattern ) )
			$result = sprintf($pattern, $path);
		if ( true === $echo )
			echo $result;
		return $result;
	}
}

$filosofo_gravatars = new filosofo_gravatars();
